drop schema if exists bmi_perf cascade;
create schema bmi_perf;
set search_path = bmi_perf, public;

CREATE FUNCTION relpages(text)
RETURNS INTEGER AS $BODY$
	select c.relpages from
	pg_catalog.pg_class c,
	pg_catalog.pg_namespace n
	WHERE n.oid = c.relnamespace
	AND n.nspname = 'bmi_perf'
	AND c.relname = $1
$BODY$ LANGUAGE SQL;

-- data tables

create table test4s (
	x	int,
	y	int,
	z	int,
	w	int
);
create table test4o (like test4s);
create table test4f (like test4s);
create table test4l (like test4s);
create table test4h (like test4s);

--

create table test2s (
	x	int,
	y	int
);
create table test2o (like test2s);
create table test2f (like test2s);
create table test2l (like test2s);
create table test2h (like test2s);

--

create table test1s (
	x	int
);
create table test1o (like test1s);
create table test1f (like test1s);
create table test1l (like test1s);
create table test1h (like test1s);

-- log tables

create table log (
	index	text,
	data	text,
	op	text,
	time	float,
	size	int,
	rows	int
);

\echo To complete installation you must execute load-data.sh
