#!/bin/bash

export LANG=C
PSQL=${PSQL:-psql}

TmpFile=$(mktemp)
TmpFileBis=$(mktemp)

### Run tests
# hash
for it in btree bitmap; do
    echo -n "[*] measuring $it indexes..."
    sed "s/__indextype__/$it/g" <template_test1.sql >$TmpFile
    $PSQL -f $TmpFile \
	| sed 's/^Total runtime:/Time:/' \
	| grep '^Time: \|^Size: \|^Test: \|^Rows: ' \
	>> $TmpFileBis
    echo " done."
done

### Process tests' output and create psql file
zTime=""
cat > $TmpFile <<EOF
set search_path = bmi_perf, public;
copy log from stdin;
EOF
while read x y1 y2 y3; do
    case $x in
	Test:)
	    if [[ ! -z "$zTime" ]]; then
		echo "$zIndex	$zData	$zOp	$zTime	$zSize	$zRows";
	    fi
	    zOp=$y1
	    zData=$y2
	    zIndex=$y3
	    zTime="\\N"
	    zSize="\\N"
	    zRows="\\N"
	    ;;
	Time:)
	    zTime=$y1
	    ;;
	Size:)
	    zSize=$y1
	    ;;
	Rows:)
	    zRows=$y1
	    ;;
    esac
done < $TmpFileBis >> $TmpFile
# flush buffer
echo "$zIndex	$zData	$zOp	$zTime	$zSize	$zRows" >>$TmpFile
echo "\\." >>$TmpFile

$PSQL -f $TmpFile

rm $TmpFile
rm $TmpFileBis
