\echo ----------------------------------------------------------------------
\echo -- This file measures the performance (time, size) of __indextype__ indexes
\echo ----------------------------------------------------------------------
\echo
\o /dev/null

\pset tuples_only
\pset format unaligned

set search_path = bmi_perf, public;
set client_min_messages = WARNING;

\echo ----------------------------------------------------------------------
\echo -- (1) Index build
\echo ----------------------------------------------------------------------

drop index if exists i1s;
\timing
\echo
\echo ---- s = sparse values -----------------------------------------------
\echo Test: build 1s __indextype__
create index i1s on test1s using __indextype__(x);
\timing
\o
select 'Size: ' || relpages('i1s') || ' pages';
\o /dev/null

drop index if exists i1o;
\timing
\echo
\echo ---- o = ordered values ----------------------------------------------
\echo Test: build 1o __indextype__
create index i1o on test1o using __indextype__(x);
\timing
\o
select 'Size: ' || relpages('i1o') || ' pages';
\o /dev/null
\echo

drop index if exists i1f;
\timing
\echo
\echo ---- f = few values --------------------------------------------------
\echo Test: build 1f __indextype__
create index i1f on test1f using __indextype__(x);
\timing
\o
select 'Size: ' || relpages('i1f') || ' pages';
\o /dev/null

\o
\echo
\echo ----------------------------------------------------------------------
\echo -- (2) SELECT with simple condition
\echo ----------------------------------------------------------------------

\echo
\echo ---- s = sparse values -----------------------------------------------
\echo Test: select 1s __indextype__
explain analyse select * from test1s where x=0;
select 'Rows: ' || count(*) from test1s where x=0;

\echo
\echo ---- o = ordered values ----------------------------------------------
\echo Test: select 1o __indextype__
explain analyse select * from test1o where x=0;
select 'Rows: ' || count(*) from test1o where x=0;

\echo
\echo ---- f = few values --------------------------------------------------
\echo Test: select 1f __indextype__
explain analyse select * from test1f where x=0;
select 'Rows: ' || count(*) from test1f where x=0;
\o /dev/null
